/*
====================
JSHINT: set options
====================
*/

/*jshint esversion: 6*/
/*jshint sub:true*/
/*jshint -W058 */

// Needs oolite >=1.82


this.name					=	"harderHermits_defender";
this.author					=	"UK_Eliter";
this.copyright				=	"";
this.description			=	"harderHermits_defender.js";
this.license				=	"2014 CC-by-nc-sa 3.0";


/*
==================
DEBUGGING SWITCHES
==================
*/

// this.logging = true;
var consoleDebugMessages	=	false; // do NOT comment this out. Rather, to disable, set to false.
this.debug					=	false;


/*
=======
GLOBALS
=======
*/



/*
========================
JSLINT: start of wrapper
========================
*/

(function () {

"use strict";


/*
=================
GENERAL FUNCTIONS
=================
*/


/*
==============
EVENT HANDLERS
==============
*/

this.shipSpawned = function ()
{
	var bounty_chanceIncrease;
	var l;
	var ordinance_available				=	new Array;
	var ordinance_available_length;
	var ordinance_capacity				=	this.shipSpawned.missileCapacity;
	var ordinance_chanceMoreTypes		=	0.2;
	var r;
	
	// BOUNTY

	switch ( this.shipSpawned.owner.primaryRole ) {
		// Role rockhermit-pirate in applicable, because
	case "rockhermit-pirate":
		bounty_chanceIncrease = 0.12;
		// Spicy Hermits sets defence ships on pirate (and only pirate) coves to 'pirate-interceptor'.
		// So they will likely have bounties already - and never will be any ships that have primary role 'hermit-ship'.
		break;
	case "rockhermit-chaotic":
		bounty_chanceIncrease = 0.4;
		break;
	default:
		bounty_chanceIncrease = 0.1;
	}
	
	r = Math.random ();
	if ( r < bounty_chanceIncrease ) {
		r = ~~( ( r * 100) + 0.5 ) / 100;
		this.ship.bounty += 5 + ( r * 200 );
	}

	// ORDINANCE

	if ( Math.Random () < ordinance_chanceMoreTypes ) {
		if ( worldScripts [ "Missiles & Bombs" ] ) {
			ordinance_available.push ( "EQ_RMB_FRAG_MISSILE", "EQ_RMB_OVERRIDE_MISSILE", "EQ_RMB_INTERCEPT_MISSILE", "EQ_RMB_INTERCEPT_MISSILE" );
		}

		if ( worldScripts [ "armoury_trackerWorldScript.js" ] ) {
			ordinance_available.push ( "EQ_ARMOURY_STUNBOMB_MINE" );
		}

		if ( EquipmentInfo.infoForKey ( "EQ_TORPEDO_MISSILE" ) ) {
			ordinance_available.push ( "EQ_TORPEDO_MISSILE"); 
		}

		if ( EquipmentInfo.infoForKey ( "EQ_HARPOON_NUKE1_MISSILE" ) ) {
			ordinance_available.push ( "EQ_HARPOON_NUKE1_MISSILE" );
		}

		if ( EquipmentInfo.infoForKey ( "EQ_NEXUS_BUG_MISSILE" ) ) {
			if ( Math.random () > 0.25 ) {
				ordinance_available.push ( "EQ_NEXUS_BASIC_MISSILE" );
			} else {
				ordinance_available.push ( "EQ_NEXUS_PREMIUM_MISSILE" );
			}
		}
	}

	// Ensure there is at least one item in the ordinance list (so that can triple the list and not get zero).
	ordinance_available.push ( "EQ_HARDENED_MISSILE" );

	// Triple the size of ordinance_available by adding, for every entry present already, a normal missile and a hardhead. 
	ordinance_available_length = ordinance_available.length;
	l = ordinance_available_length;
	while ( l -- ) {
		ordinance_available.push ( "EQ_MISSILE" );
		ordinance_available.push ( "EQ_HARDENED_MISSILE" );
	}

	// Load the ordinance (save for Q-Mine, which may have been loaded above).
	ordinance_available_length = ordinance_available.length; // The latter has changed, so set the former again.
	l = ordinance_capacity;
	do {
		this.ship.awardEquipment ( ordinance_available [ ~~ ( Math.Random () * ordinance_available_length ) ] );
	}
	while ( l-- );

	// Clean up
	delete this.shipSpawned;
};

/*
=======================
JSHINT: end of wrapper
=======================
*/

}).call ( this );


// EOF
